package com.mobvcasting.gettweets;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class GetTweets extends Activity 
{
	// Don't forget Permissions
	// <uses-permission android:name="android.permission.INTERNET" />
 
	// Twitter Search API
	// http://apiwiki.twitter.com/Twitter-Search-API-Method%3A-search
	String theURLString = "http://search.twitter.com/search.atom?q=itp";
	URL theURL;
	
	StringBuffer theResults;

	Button getTweetB;
	TextView tweetView;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        theResults = new StringBuffer();
                
        tweetView = (TextView) this.findViewById(R.id.TextView01);
        
        getTweetB = (Button) this.findViewById(R.id.Button01);
        getTweetB.setOnClickListener(
        	new OnClickListener() 
        	{
				public void onClick(View v) 
				{
					tweetView.setText("Button was clicked");
					
			        try 
			        {
			        	theURL = new URL(theURLString);
			        	
			            BufferedReader in = new BufferedReader(new InputStreamReader(theURL.openStream()));
			            String str;
			            while ((str = in.readLine()) != null) 
			            {
			            	theResults.append(str);

			            	// For debugging
			            	//tweetView.append(str);
			            }
			            in.close();			        
			            
			            // Now do parsing.. 
			            // The right way is here:
			            // http://www.ibm.com/developerworks/opensource/library/x-android/index.html
			            
			            // This is the quick and dirty way
			            String[] messages = findStringsBetweenInString("<title>","</title>",theResults.toString());
			            
			            // Debugging
			            for (int i = 0; i < messages.length; i++)
			            {
			            	Log.v("FOUND", messages[i]);
			            	tweetView.append(messages[i] + "\n");
			            }
			        }
			        catch (MalformedURLException mue) 
			        {
			        	tweetView.setText(mue.getMessage());
			        } 
			        catch (IOException e) 
			        {
			        	tweetView.setText(e.getMessage());
			        }
				}
			}
        );
    }
        
    String[] findStringsBetweenInString(String tofindstart, String tofindend, String source)
    {
    	ArrayList<String> returnArray = new ArrayList<String>();
    	
    	int startfound = 0;
    	while (true)
    	{
    		startfound = source.indexOf(tofindstart,startfound);
    		if (startfound != -1) 
    		{
        		startfound += tofindstart.length();
    			int endfound = source.indexOf(tofindend,startfound);
    			if (endfound != -1)
    			{    				
    				String foundstring = source.substring(startfound,endfound);
    				returnArray.add(foundstring);
    			}
    			else
    			{
    				break;
    			}
    		}
    		else
    		{
    			break;
    		}
    	}
    	
    	String[] returnStrings = new String[returnArray.size()];
    	returnArray.toArray(returnStrings);
    	return returnStrings;
    }
}